define_constants;
% load('Arashcase48newestGAMS.mat');
%NESTA archive cases a good choice as they contain RATE_A data
BaseCase = loadcase('case24_ieee_rts_2_area_proper'); 

%case9
%case24_ieee_rts_2_area_proper
%case2383wp
%nesta_case73_ieee_rts
%nesta_case118_ieee
%nesta_case57_ieee
%case1354pegase
%nesta_case1460wp_eir
%case2383wp

BaseCase.bus(:, PD) = BaseCase.bus(:, PD) * 0.75

TestCase = ext2int( rundcopf((BaseCase))); %Just in case bus numbers are all out of whack
TestCase = rmfield(TestCase,'order');

MergedSys = MakeMergedSystem(TestCase);

MergedSys = rundcopf(MergedSys)

Pbus = real(makeSbus(MergedSys.baseMVA, MergedSys.bus, MergedSys.gen))

 DirWeightedSystemGraph = SimpleMakeDirGraph(MergedSys); %NB check this function didn't mess up the JETCAS results [ED: it didn't!]

 
 NumNodes = size(DirWeightedSystemGraph.Nodes,1);
 NumEdges = size(DirWeightedSystemGraph.Edges,1);



for UU=1:Nb
   TopoSortMap(:,UU)=PosSorted(:,UU); 
end
nnn=1;
for UU=(Nb+1):(2*Nb)
   TopoSortMap(:,UU)=PosSortedReverse(:,nnn);
   nnn=nnn+1;
end

   FullRec = {};
     TopoFrontier= [];
    
 for ThisSort = 1:size(TopoSortMap,2) %---------- 
 
    ThisDescentSet = TopoSortMap(:, ThisSort); %put the source at the top
    
    for ThisCut = 1:size(ThisDescentSet,1)-1
    
        InNodes = ThisDescentSet(1:ThisCut,1);
        
        [GraphBridgeEdges, SignedOutwardFlow] = cutdigraph(DirWeightedSystemGraph, InNodes);
        
        TesterGraph = (rmedge(DirWeightedSystemGraph, GraphBridgeEdges));
        
        Adj = adjacency(TesterGraph);
        
        SplitGraph = graph(Adj + Adj');%make it undirected
        
        IslandCheck = max(conncomp(SplitGraph));
        
        BridgeEdges = DirWeightedSystemGraph.Edges.BranchIndex(GraphBridgeEdges);
        
        FullRec = [FullRec; {size(BridgeEdges,1), SignedOutwardFlow, BridgeEdges, ThisSort, ThisCut, IslandCheck}]; %sum(Pbus(InNodes))
        
        TopoFrontier = [TopoFrontier; size(BridgeEdges,1), SignedOutwardFlow, ThisCut, ThisSort, IslandCheck];
        
    end
    
 end
 
 FullRec = sortrows(FullRec,1)
  
for ThisCrackCalc = 1:size(FullRec,1) %The crack analysis is only legitimate for cutsets that split the network into two connected components
 
 
 [CrackSet] = FindCrackSet(MergedSys,  FullRec{ThisCrackCalc, 3});
 
 FullRec(ThisCrackCalc, 7) = {CrackSet};
 FullRec(ThisCrackCalc, 8) = {size(CrackSet,1)}; 
 
end
 
 FullRec = sortrows(FullRec,5)

 

  

  


  CapacityMatrix = zeros(NumNodes, NumNodes); % simulated damage by MATCASC
 
 FromBuses = MergedSys.branch(:, F_BUS);
 ToBuses = MergedSys.branch(:, T_BUS);
 
 LinIndices = sub2ind(size(CapacityMatrix), FromBuses, ToBuses)
 
 CapacityMatrix(LinIndices) =  MergedSys.branch(:, RATE_A); %OR RATE_C??
 
 LinIndices = sub2ind(size(CapacityMatrix), ToBuses, FromBuses)
 
 CapacityMatrix(LinIndices) =  MergedSys.branch(:, RATE_A);

histogram([FullRec{:,5}])

 AllCracks = vertcat(FullRec{:,4});
 
 histogram(AllCracks)
 
 AttackSet = find( ([FullRec{:,8}] < 6)  & ([FullRec{:,6}] == 2) );
 
 ReducedRec = FullRec(AttackSet',:)
 
 TotalDemand = sum(MergedSys.bus(:, PD));
 
 for ThisAttack = 1:size(ReducedRec,1)
 
LinksToAttack = ReducedRec{ThisAttack,7};

OutEdges = [MergedSys.branch(LinksToAttack, F_BUS), MergedSys.branch(LinksToAttack, T_BUS)];


[JamFlowStageResult,JamFlowMatrix, JamAlreadyRemovedLines,JamGenerationVector] = MySimCascFailures(MergedSys, CapacityMatrix, OutEdges);

NumIslands = size(JamFlowStageResult{end},2);

NumFinalBuses = size(JamFlowStageResult{end}(1).capacityMatrix,1);

ReducedRec(ThisAttack, 9) = {TotalDemand * (1-JamDemandSurvivability)};

ReducedRec(ThisAttack, 10) = {NumIslands};

ReducedRec(ThisAttack, 11) = {JamFlowStageResult};

ReducedRec(ThisAttack, 12) = {NumFinalBuses};


 end