clc
define_constants;

%NESTA archive cases a good choice as they contain RATE_A data
BaseCase = loadcase('case24_ieee_rts_2_area_proper'); 

%case9
%case24_ieee_rts_2_area_proper
%case2383wp
%nesta_case73_ieee_rts
%nesta_case118_ieee
%nesta_case57_ieee
%case1354pegase
%nesta_case1460wp_eir
%case2383wp

BaseCase.bus(:, PD) = BaseCase.bus(:, PD) 

TestCase = ext2int( rundcopf((BaseCase))); %Just in case bus numbers are all out of whack
TestCase = rmfield(TestCase,'order');

MergedSys = MakeMergedSystem(TestCase);

MergedSys = rundcopf(MergedSys)

Pbus = real(makeSbus(MergedSys.baseMVA, MergedSys.bus, MergedSys.gen))

 DirWeightedSystemGraph = SimpleMakeDirGraph(MergedSys)
FT=DirWeightedSystemGraph.Edges.EndNodes;
Nb=size(MergedSys.bus,1);

B2B=zeros(Nb,Nb);
for l=1:size(FT,1)
    B2B(FT(l,1),FT(l,2))=1; 
end


pos_index={};
for i=1:Nb
    pos_index(i)=cellstr(['p' num2str(i)]);
end


PosSet.name = 'i';
PosSet.type = 'set';
PosSet.form = 'full';
PosSet.uels= {pos_index};


BB.name = 'BBIM';
BB.type = 'parameter';
BB.val = B2B;
BB.form = 'full';
BB.uels= {pos_index pos_index};

NoBus.name = 'NB';
NoBus.type = 'parameter';
NoBus.val = Nb;
NoBus.form = 'full';


for b=1:Nb
    optim_index=b;
    OIV0=zeros(1,Nb);
    OIV0(optim_index)=1;

    OLV.name = 'OI';
    OLV.type = 'parameter';
    OLV.val = OIV0;
    OLV.form = 'full';
    OLV.uels= {pos_index};
    wgdx ('MatToGams', BB, NoBus, OLV, PosSet);
    system 'gams PosFinder gdx=solution'
    pos0.name='pos';
    PosFinal=rgdx('D:\papers\solution.gdx',pos0);
    PosF=PosFinal.val;
    for j=1:Nb
        PosSorted(round(PosF(j,2)),b)=PosF(j,1);
    end
end
for b=1:Nb
    optim_index=b;
    OIV0=zeros(1,Nb);
    OIV0(optim_index)=-1;

    OLV.name = 'OI';
    OLV.type = 'parameter';
    OLV.val = OIV0;
    OLV.form = 'full';
    OLV.uels= {pos_index};
    wgdx ('MatToGams', BB, NoBus, OLV, PosSet);
    system 'gams PosFinder gdx=solution'
    pos0.name='pos';
    PosFinal=rgdx('D:\papers\solution.gdx',pos0);
    PosF=PosFinal.val;
    for j=1:Nb
        PosSortedReverse(round(PosF(j,2)),b)=PosF(j,1);
    end
end

save finalResults PosSorted PosSortedReverse

clc